#include<R.h>
#include<Rmath.h>

void myrnorm(int *n, double *m, double *s, double *res) { 
  int i;
  GetRNGstate();
  for (i=0; i<*n; i++) 
    res[i] = rnorm(*m, *s);
  PutRNGstate();
}

void myrnorm2(int *n, double *m, double *s, double *res) { 
  int i;
  GetRNGstate();
  for (i=0; i<*n; i++) 
    res[i] = rnorm(m[i], s[i]);
  PutRNGstate();
}

void myrpois(int *n, double *lamb, int *res) {
  int i; 
  GetRNGstate();
  for (i=0; i<*n; i++) 
    res[i] = rpois(*lamb);
  PutRNGstate();
}

void mydnorm(int *n, double *x, double *m, double *s, double *res) {
  int i;
  for (i=0; i<*n; i++) 
    res[i] = dnorm(x[i], m[i], s[i], 0);
}

void mydpois(int *n, int *x, double *lamb, double *res) {
  int i;
  for (i=0; i<*n; i++) 
    res[i] = dpois(x[i], lamb[i], 0);
}

void myppois(int *n, int *x, double *lamb, double *res) {
  int i;
  for (i=0; i<*n; i++) 
    res[i] = ppois(x[i], lamb[i], 0, 0);
}

void myqpois(int *n, double *x, double *lamb, int *res) {
  int i; 
  for (i=0; i<*n; i++) 
    res[i] = qpois(x[i], lamb[i],1,0);
}
